<template>
  <sui-modal
    v-model="isVisible"
    size="mini"
    v-scroll-lock="isVisible"
    v-dom-move
    :animation-duration="1">

    <i
      class="close icon"
      @click="isVisible = false"/>

    <div class="content">
      <form
        class="ui form"
        novalidate
        :class="{ loading }"
        @submit.prevent="send">
        <div class="title">Начать чат с продавцом</div>

        <div
          class="field"
          :class="{invalid: validation.hasError('name')}">
          <label>Как к вам обращаться <span class="red">*</span>
          </label>
          <div class="ui input">
            <input
              type="text"
              v-model="name"
              placeholder="Имя">
          </div>
          <div
            v-if="validation.hasError('name')"
            class="message error">
            {{ validation.firstError('name') }}
          </div>
        </div>

        <div
          class="field"
          :class="{invalid: validation.hasError('email')}">
          <label>Укажите адрес электронной почты</label>
          <div class="ui input">
            <input
              type="text"
              v-model="email"
              placeholder="E-mail">
          </div>
          <div
            v-if="issetErrors.email || validation.hasError('email')"
            class="message error">
            {{ issetErrors.email || validation.firstError('email') }}
            <span v-if="issetErrors.email">
              <br>
              <a
                href="#"
                @click.prevent="isVisible = false; showAuthModal();">Авторизуйтесь</a>
              или укажите другой e-mail.
            </span>
          </div>
        </div>

        <div class="field">
          <label>Укажите ваш телефон, если хотите, чтобы продавец ответил максимально оперативно</label>
          <AppInputPhone
            v-model="phone"
            @has-error="inputErrors.phone = $event"/>
          <div
            v-if="issetErrors.phone"
            class="message error">
            {{ issetErrors.phone }}
            <span v-if="issetErrors.phone">
              <br>
              <a
                href="#"
                @click.prevent="isVisible = false; showAuthModal();">Авторизуйтесь</a>
              или укажите другой номер телефона.
            </span>
          </div>
        </div>

        <div class="text-agreement">
          Нажимая на кнопку &laquo;Начать чат&raquo; вы даете согласие на
          <flink
            target="_blank"
            domain="main"
            href="/about-us/agreement"
            class="kit aqualink">обработку персональных данных
          </flink>
        </div>

        <div
          v-if="apiError"
          class="error-message">
          Временная ошибка, пожалуйста, повторите запрос позднее
        </div>

        <button
          type="submit"
          :disabled="submitDisabled"
          class="ui button yellow circular inmodal">
          Начать чат
        </button>
      </form>
    </div>
  </sui-modal>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';

import {
  SHOW_BEGIN_CHAT_MODAL,
  HIDE_BEGIN_CHAT_MODAL,
} from '~/assets/js/store/actionManager/mutation-types';
import BeginChatMixin from '~/assets/js/mixins/begin-chat';

import AppInputPhone from '~/components/redesign/app-input/app-input-phone';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');

export default {
  name: 'BeginChatModal',
  components: {
    AppInputPhone,
  },
  mixins: [BeginChatMixin],
  computed: {
    ...STORE_ACTION_MANAGER.mapState({
      shown: 'beginChatModal',
    }),
  },
  watch: {
    isVisible(newValue, oldValue) {
      if (newValue !== oldValue && !newValue) {
        this.$ym('chat_guest_modal_closed');
      }
    },
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      show: SHOW_BEGIN_CHAT_MODAL,
      hide: HIDE_BEGIN_CHAT_MODAL,
    }),
  },
};
</script>

<style scoped lang="scss">
  .ui.modal > .content {
    display: block;
  }

  .ui.form {
    width: 100%;
    .red {
      color: #E13C3C;
    }
    .title {
      display: block;
      width: 100%;
      text-align: center;
      font-size: 1.125rem;
      line-height: 1.3;
      font-weight: 700;
      padding: 1.5rem 0 1rem;
    }
    .ui.button {
      display: block;
      margin: 1rem auto;
    }
    .error-message,
    .text-agreement {
      display: block;
      padding: 1rem 0 0 1rem;
      font-size: 0.6875rem;
      line-height: 1.3;
      font-weight: 400;
      @media only screen and (max-width: 1024px) {
        font-size: 0.8125rem;
      }
    }
    .error-message {
      color: #E13C3C;
    }
  }
</style>
